// LibAIMPRemote.cpp : Defines the exported functions for the DLL application.
//

#include "stdafx.h"
#include "aimpremote_AIMP.h"
#include "apiRemote.h"

#define WRITE_TO_STRING_ARRAY(i, x) \
    memcpy(charBuffer, pBuff, (x) * 2); \
    charBuffer[x] = '\0'; \
    pBuff += (x); \
    env->SetObjectArrayElement(info, (i), env->NewString(charBuffer, (x)));

JNIEXPORT jobjectArray JNICALL Java_aimpremote_AIMP_currentTrack
  (JNIEnv *env, jclass jobj) {
    HANDLE hAIMP = OpenFileMapping(FILE_MAP_READ, false, AIMPRemoteAccessClass);
    if (!hAIMP) {
        return NULL;
    }

    jobjectArray info = env->NewObjectArray(3, env->FindClass("java/lang/String"), 0);

    PAIMPRemoteFileInfo aimpFileInfo = (PAIMPRemoteFileInfo) 
        MapViewOfFile(hAIMP, FILE_MAP_READ, 0, 0, AIMPRemoteAccessMapFileSize);

    if (aimpFileInfo) {
        LPWSTR pBuff = (LPWSTR)((PBYTE)aimpFileInfo + sizeof(TAIMPRemoteFileInfo));
        jchar charBuffer[256];

        WRITE_TO_STRING_ARRAY(2, aimpFileInfo->AlbumLength);
        WRITE_TO_STRING_ARRAY(0, aimpFileInfo->ArtistLength);
        pBuff += aimpFileInfo->DateLength
            + aimpFileInfo->FileNameLength
            + aimpFileInfo->GenreLength;
        WRITE_TO_STRING_ARRAY(1, aimpFileInfo->TitleLength);
    }

    UnmapViewOfFile(aimpFileInfo);

    return info;
}

